%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Display the results of the WaRD algorithm
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% the observation is shifted by (4,4) towards the top-left corner to minize
% the ISNR.

temp = Y;
for shifti = 1:5
  for shiftj = 1:5
    conv_mat = 0* Conv_mat;
    conv_mat(N-shifti+1,N-shiftj+1) = 1;  
    Y1 = real(ifft2(fft2(temp) .* fft2(conv_mat)));
    cost(shifti,shiftj) = norm(X(:)-Y1(:))^2;
  end    
end
[minshifti, minshiftj] = find(cost == min(cost(:)));

conv_mat = 0* Conv_mat;
conv_mat(N-minshifti+1,N-minshiftj+1) = 1;  
Y1 = real(ifft2(fft2(temp) .* fft2(conv_mat)));

Y = Y1;

figure(1)
subplot(2,2,2)
imagesc(X)
colormap('gray')
im_range = get(gca,'CLim');
imagesc(Y, im_range)
axis('square')
rmaxis
title(strcat('Noisy image, SNR = ', num2str(BSNR),'dB'))

subplot(2,2,1)
imagesc(X, im_range)
axis('square')
rmaxis
title(strcat('Original image'))

subplot(2,2,3)
imagesc(Wiener_Estimate, im_range)
axis('square')
rmaxis
ISNR_Wiener = 10*log10(norm(X(:)-Y(:))^2 /norm(Wiener_Estimate(:) - X(:))^2 );
SNR_Wiener = 10*log10(norm(X(:))^2 /norm(Wiener_Estimate(:) - X(:))^2 );
title(strcat('Wiener, ISNR =',num2str(ISNR_Wiener),'dB, SNR =',num2str(SNR_Wiener),'dB'))

subplot(2,2,4)
imagesc(x_ward, im_range)
axis('square')
rmaxis
ISNR_WDWF = 10*log10(norm(X(:) - Y(:))^2 /norm(x_ward(:) - X(:))^2 );
SNR_WDWF = 10*log10(norm(X(:))^2 /norm(x_ward(:) - X(:))^2 );
title(strcat('WaRD, ISNR = ', num2str(ISNR_WDWF), 'dB, SNR = ', num2str(SNR_WDWF),'dB'))

if 1 == 0
  Disp_results
end
